/********************************************************************
 *
 * - naesbind.h -
 *
 * Modulschnittstelle von naesbind.c
 *
 * PureC-Version, 1996 by Jens Hiescher
 *
 ********************************************************************/

#include <aes.h>

/********** aus Pure C - Lib **********/

void 	_aes(int dummy, long parm);


/********** Prototypen der zustzlichen N.AES-Calls: **********/

int		appl_control(int ap_cid, int ap_cwhat, void *ap_cout);
int		appl_yield(void);

int		form_popup(OBJECT *tree, int x, int y);

int		graf_multirubber(int x, int y, int minw, int minh, GRECT *rec, 
						int *outw, int *outh);

int		objc_xfind(OBJECT *obj, int start, int depth,  int x, int y);

int		shel_help(int sh_hmode, char *sh_hfile, char *sh_hkey);

int    shel_rdef(char *lpcmd, char *lpdir);
int    shel_wdef(char *lpcmd, char *lpdir);

int    wind_draw(int wi_dhandle, int wi_dstartob);
int    wind_sget(int w_handle, int w_field, char *buff);

/********** Konstanten **********/

									/* appl_control[ap_cwhat]: 						*/
#define APC_APP			0			/* Zeiger auf APP-Struktur liefern			*/
#define APC_VANISHED	1			/* Applikation ist MiNT-mig terminiert	*/
#define APC_HIDE		10			/* Anwendung ausblenden */
#define APC_SHOW		11			/* Anwendung einblenden */
#define APC_TOP			12			/* Anwendung in den Vordergrund bringen */
#define APC_HIDENOT		13			/* Alle anderen ausblenden */
#define APC_INFO		14			/* Abfrage von Parametern    */
#define     APCI_HIDDEN     0x0001  /* 1, wenn ausgeblendet     */
#define     APCI_HASMBAR    0x0002  /* 1, wenn Menleiste vorh. */
#define     APCI_HASDESK    0x0004  /* 1, wenn Desktop vorh.    */
#define APC_MENU        15          /* Erfragen des Menbaums    */

									/* menu_bar 									*/
#define MENU_GETMODE	3			/* Menleistenmodus abfragen				*/
#define MENU_SETMODE	4			/* Menleistenmodus setzen (nicht implem.)	*/
#define		MENU_HIDDEN		0x0001	/* Menleiste nur bei Bedarf sichtbar		*/
#define		MENU_PULLDOWN	0x0002	/* Pulldown-Men (aufklappen bei Mausklick)	*/
#define		MENU_SHADOWED	0x0004	/* Menleistenboxen mit Schatten			*/
#define MENU_UPDATE		5			/* Update des Systemteils der Menleiste	*/

									/* shel_write									*/
#define AP_AESTERM		52			/* fr mode 10: N.AES komplett terminieren	*/

									/* shel_help */
#define SHP_HELP		0			/* Hilfe aufrufen							*/
